from cuttlefish.actions import CuttleAction
from cuttlefish.plugins import CuttlePlugin

import dbus

class Suspend(CuttleAction, CuttlePlugin):
	NAME = 'Suspend'
	DESCP = 'Suspend the computer'
	CATEGORY = 'Power Management'

	def __init__(self):
		CuttleAction.__init__(self)
		CuttlePlugin.__init__(self)

	def execute(self):
		bus = dbus.SystemBus()
		obj = bus.get_object('org.freedesktop.UPower', '/org/freedesktop/UPower')
		upower = dbus.Interface(obj, 'org.freedesktop.UPower')
		
		upower.Suspend()


class Hibernate(CuttleAction, CuttlePlugin):
	NAME = 'Hibernate'
	DESCP = 'Hibernate the computer'
	CATEGORY = 'Power Management'

	def __init__(self):
		CuttleAction.__init__(self)
		CuttlePlugin.__init__(self)
		
	def execute(self):
		bus = dbus.SystemBus()
		obj = bus.get_object('org.freedesktop.UPower', '/org/freedesktop/UPower')
		upower = dbus.Interface(obj, 'org.freedesktop.UPower')
		
		upower.Hibernate()


class Shutdown(CuttleAction, CuttlePlugin):
	NAME = 'Shutdown'
	DESCP = 'Shut down the computer'
	CATEGORY = 'Power Management'

	def __init__(self):
		CuttleAction.__init__(self)
		CuttlePlugin.__init__(self)

	def execute(self):
		bus = dbus.SystemBus()
		obj = bus.get_object('org.freedesktop.ConsoleKit', '/org/freedesktop/ConsoleKit/Manager')
		consoleKit = dbus.Interface(obj, 'org.freedesktop.ConsoleKit.Manager')
		
		consoleKit.Stop()


class Reboot(CuttleAction, CuttlePlugin):
	NAME = 'Reboot'
	DESCP = 'Reboot the computer'
	CATEGORY = 'Power Management'

	def execute(self):
		bus = dbus.SystemBus()
		obj = bus.get_object('org.freedesktop.ConsoleKit', '/org/freedesktop/ConsoleKit/Manager')
		consoleKit = dbus.Interface(obj, 'org.freedesktop.ConsoleKit.Manager')
		
		consoleKit.Restart()


