from cuttlefish.actions import CuttleAction
from cuttlefish.plugins import CuttlePlugin
from cuttlefish.params import SelectParam

from cuttlefish.reflexes import REFLEXES

class ChangeReflex(CuttleAction):
	CATEGORY = "Reflexes"
	PARAMS = {
		'reflex' : ''
	}
	
	class Editor(CuttlePlugin.Editor):
		def begin(self):
			rdict = {}
			for r in REFLEXES.list():
				rdict[r.record_id] = r['name']

			return {
				'reflex': SelectParam('Reflex', rdict, str)
			}


	def __init__(self, activate):
		CuttleAction.__init__(self)
		self._activate = activate

	def execute(self):
		r = REFLEXES.get(self._params['reflex'])
		r['event']['isActive'] = self._activate
		REFLEXES.save(r)



class ActivateReflex(ChangeReflex, CuttlePlugin):
	NAME = "Activate reflex"
	DESCP = "Activate another reflex"

	def __init__(self):
		ChangeReflex.__init__(self, True)
		CuttlePlugin.__init__(self)


class DeactivateReflex(ChangeReflex, CuttlePlugin):
	NAME = "Deactivate reflex"
	DESCP = "Deactivate another reflex"

	def __init__(self):
		ChangeReflex.__init__(self, False)
		CuttlePlugin.__init__(self)